#import "Book.h"
#import <stdio.h>					// for printf, fgets
#import <stdlib.h>					// for atoi
#define MAXLENGTH 100				// 記号定数

void showBook(int i, id books);	// Book のデータを表示する関数のプロトタイプ
void addBook(id book);			// Book にデータを格納する関数のプロトガイプ
								// 以前の enterBook 関数はなくなっています。
int main(void) {
	char ss[MAXLENGTH];		// ターミナルで入力された文字列を受ける変数
	Book *book;				// Book 型のインスタンスをポイントする変数
	NSMutableArray *books;	// NSMutableArray 型のインスタンスをポイントする変数
	BOOL quit;				// プログラムの終了が選択されているかどうかを表すフラッグ
	BOOL exist;				// 検索した名前が存在していたかどうかを表すフラッグ
	int  i, j;				// for ループで使う整数値型変数	

	books = [NSMutableArray array];
	quit = NO;
	
	while ( ! quit ) {
		printf("表示=1 指定=3 追加=5 削除=7 終了=9 ");
		fgets(ss, MAXLENGTH, stdin);
		
		switch (atoi(ss)) {
				
			case 1:
				j = [books count];
				if (j == 0) {
					printf("何も登録がありません。\n");	
				} else {
					for (i=0; i<j; i++) {
						showBook(i, books);
					}
				}
				break;
				
			case 3:
				j = [books count];
				if (j == 0) {
					printf("何も登録がありません。\n");
				} else {
					printf("お名前は:");
					fgets(ss, MAXLENGTH, stdin);
					exist = NO;
					for (i=0; i<j; i++) {
						if ([[[books objectAtIndex:i] name] isEqualToString:[NSString stringWithUTF8String:ss]]) {
							showBook(i, books);
							exist = YES;
						}
					}
					if (! exist) {
						printf("お名前が見つかりませんでした。\n");
					}
				}
				break;
				
			case 5:
				book = [[Book alloc] init];
				addBook(book);
				[books addObject:book];
				break;
				
			case 7:
				j = [books count];
				if (j == 0) {
					printf("何も登録がありません。\n");
				} else {
					printf("お名前は？:");
					fgets(ss, MAXLENGTH, stdin);
					exist = NO;
					for (i=0; i<j; i++) {
						if ([[[books objectAtIndex:i] name] isEqualToString:[NSString stringWithUTF8String:ss]]) {
							[books removeObjectAtIndex:i];
							printf("削除しました。\n");
							exist = YES;
							break;
						}
					}
					if (! exist) {
						printf("お名前が見つかりませんでした。\n");
					}
				}
				break;
				
			case 9:
				quit = YES;
				break;
		}
	}
	return 0;
}

void showBook(int i, id books) {
	puts("------------------------------");

	// cStringUsingEncoding の引数は97行目のようにすべきですが、98行目からは簡易的に4としている
	
	printf("%s", [[[books objectAtIndex:i] name] cStringUsingEncoding:NSUTF8StringEncoding]);
	printf("%s", [[[books objectAtIndex:i] address] cStringUsingEncoding:4]);
	printf("%s", [[[books objectAtIndex:i] phone] cStringUsingEncoding:4]);
	printf("%s", [[[books objectAtIndex:i] email] cStringUsingEncoding:4]);
}

void addBook( id book) {
	char ss[MAXLENGTH];		// ターミナルで入力された文字列を受け取る変数
	
	printf("氏　　名:");
	fgets(ss, MAXLENGTH, stdin);
	[book setName:[NSString stringWithUTF8String:ss]];
	printf("住　　所:");
	fgets(ss, MAXLENGTH, stdin);
	[book setAddress:[NSString stringWithUTF8String:ss]];
	printf("電話番号:");
	fgets(ss, MAXLENGTH, stdin);
	[book setPhone:[NSString stringWithUTF8String:ss]];
	printf("Ｅメール:");
	fgets(ss, MAXLENGTH, stdin);
	[book setEmail:[NSString stringWithUTF8String:ss]];
}
	